import React, { useState, useEffect } from "react";
import { useNavigate } from "react-router-dom";
import { useParams } from "react-router-dom";
import { Link } from "react-router-dom";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faHeart, faShoppingCart } from "@fortawesome/free-solid-svg-icons";
import "./index.css";
import { Header } from "../../Components/Header";

import { ImageSlide2 } from "../../Components/imageslide2";
import { Footer } from "../../Components/footer";

import axios from "axios";
import { ToastContainer, toast } from 'react-toastify';
import 'react-toastify/dist/ReactToastify.css';

// breadcrums images
import image from "../../Assests/Images/darkbread.jpg";
import image2 from "../../Assests/Images/line.png";
import image3 from "../../Assests/Images/sprade-light.png";
//bread-crums image end

export const Products = () => {

    const navigate = useNavigate();
    const [products, setProducts] = useState([]);
    const [user, setUser] = useState(null);
    const [users, setUsers] = useState({ totalUser: 0, totalVolunteer: 0 });
    const { id } = useParams();


    const [user_id, setUserId] = useState("");
    const [quantity, setQuantity] = useState(1);

    useEffect(() => {
        const storedUser = JSON.parse(localStorage.getItem("user"));
        if (storedUser) {
            setUser(storedUser);
        }
    }

        , []);
    

    
    
        // const handleAddToWishlist = async (productId) => {
        //     const formData = new FormData();
        //     formData.append("user_id", user?.id);
        //     formData.append("product_id", productId);
            
        //     try {
        //         const response = await axios.post('http://localhost:8000/api/wishlists', formData);
        //         if (response?.data?.success) {
        //             toast.success('Wish Created Successfully', { position: "bottom-right" });
        //         }
        //     } catch (error) {
        //         console.error("Error creating wishlist:", error);
        //         toast.error('Failed to create wishlist', { position: "bottom-right" });
        //     }
        // };
        
    // const handleAddToCart = async (productId) => {
    //     const formData = new FormData();
    //     formData.append("user_id", user?.id);
    //     formData.append("product_id", productId);
    //     formData.append("quantity", quantity);

    //     try {
    //         const response = await axios.post('http://localhost:8000/api/carts', formData);
    //         if (response?.data?.success) {
    //             toast.success('Added to Cart Successfully', { position: "bottom-right" });
    //         }
    //     } catch (error) {
    //         console.error("Error adding to cart:", error);
    //         toast.error('Failed to add to cart', { position: "bottom-right" });
    //     }
    // }   

    const handleAddToCart = async (productId) => {
        if (!user) {
            toast.error('Please login first!', { position: "bottom-right" });
            navigate('/login');  // redirect to login page (optional)
            return;
        }
    
        const formData = new FormData();
        formData.append("user_id", user.id);
        formData.append("product_id", productId);
        formData.append("quantity", quantity);
    
        try {
            const response = await axios.post('http://localhost:8000/api/carts', formData);
            if (response?.data?.success) {
                toast.success('Added to Cart Successfully', { position: "bottom-right" });
            }
        } catch (error) {
            console.error("Error adding to cart:", error);
            toast.error('Failed to add to cart', { position: "bottom-right" });
        }
    };




    const handleAddToWishlist = async (productId) => {
        if (!user) {
            toast.error('Please login first!', { position: "bottom-right" });
            navigate('/login');
            return;
        }
    
        const formData = new FormData();
        formData.append("user_id", user.id);
        formData.append("product_id", productId);
    
        try {
            const response = await axios.post('http://localhost:8000/api/wishlists', formData);
            if (response?.data?.success) {
                toast.success('Wish Created Successfully', { position: "bottom-right" });
            }
        } catch (error) {
            console.error("Error creating wishlist:", error);
            toast.error('Failed to create wishlist', { position: "bottom-right" });
        }
    };
    



    useEffect(() => {
        const fetchProducts = async () => {
            try {
                const response = await fetch("http://localhost:8000/api/products");
                const data = await response.json();
                if (data.success) {
                    setProducts(data.data);
                } else {
                    console.error("Failed to fetch products:", data.message);
                }
            } catch (error) {
                console.error("Error fetching products:", error);
            }
        };

        fetchProducts();
    }
        , []);


        













    return (
        <>
            <div className="training-center">
                <ToastContainer />
                <Header />

                <div className="breadcrums">
                    <div className="breadcrums-imgbx">
                        <img src={image} alt="" />
                    </div>
                    <div className="breadcrums-content">
                        <h1>Products</h1>
                    </div>

                    <div className="breadcrums-front-img">
                        <img src={image2} alt="" />
                    </div>

                    <div className="stiker">
                        <img src={image3} alt="" />
                    </div>

                    <div className="bread-crums-main-content">
                        <div className="sub-content">
                            <a href="">Home</a>
                            <span>/</span>
                            <a href="">Products</a>
                        </div>
                    </div>
                </div>

                <div className="t-centers">
                    {products.map((product) => (
                        <div className="t-center-card">
                            <div className="t-center-img-bx" style={{ height: "300px" }}>
                                <img src={`http://localhost:8000/${product.image}`} alt="" />
                            </div>
                            <div className="t-center-content">
                                <h2>{product.title}</h2>
                                <p>{product.description}</p>
                                <div className="border-line"></div>
                                <p>Price :<span>{product.price}</span>/=</p>

                                <form action="" className="products-btns" >
                                    <input type="hidden" value={user_id} />
                                    <input type="hidden" value={id} />
                                    <input type="hidden" value={quantity} />
                                    <button type="button" onClick={() => handleAddToWishlist(product.id)}>
                                        <FontAwesomeIcon icon={faHeart}  />
                                    </button>

                                    <button type="button" onClick={() => handleAddToCart(product.id)}>
                                        <FontAwesomeIcon icon={faShoppingCart} />
                                    </button>
                                </form>



                            </div>
                        </div>
                    ))}

                </div>

                <ImageSlide2 />
                <Footer />
            </div>
        </>
    );
};
